#include "testlib.h"
#include <vector>

int calc_vis_for_part(const std::vector<int> &plan, const std::tuple<int, int, int> &wish) {
    auto [a, b, c] = wish;
    if (plan[a] == plan[b] && plan[b] == plan[c]) return 1;
    if (plan[a] == plan[b] || plan[b] == plan[c] || plan[a] == plan[c]) return 2;
    return 3;
}

int calc_vis(const std::vector<int> &plan, const std::vector<std::tuple<int, int, int>> &wishes) {
    int cnt = 0;
    for (auto wish: wishes) {
        cnt += calc_vis_for_part(plan, wish);
    }
    return cnt;
}

std::vector<int> read_part_ans() {
    std::vector<int> plan(12, -1);
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 4; ++j) {
            int x = ouf.readInt(1, 12, "x"); --x;
            quitif(plan[x] != -1, _wa, "Section %d occurs twice in participant's answer", x + 1);
            plan[x] = i;
        }
    }
    return plan;
}

std::vector<int> read_jury_ans() {
    std::vector<int> plan(12, -1);
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 4; ++j) {
            int x = ans.readInt(1, 12, "x"); --x;
            quitif(plan[x] != -1, _fail, "Section %d occurs twice in jury's answer", x + 1);
            plan[x] = i;
        }
    }
    return plan;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    
    int n = inf.readInt();
    std::vector<std::tuple<int, int, int>> wishes(n);
    for (int i = 0; i < n; ++i) {
        int a = inf.readInt();
        int b = inf.readInt();
        int c = inf.readInt();
        --a, --b, --c;
        wishes[i] = {a, b, c};
    }
    
    auto pans = calc_vis(read_part_ans(), wishes);
    auto jans = calc_vis(read_jury_ans(), wishes);
    
    quitif(pans > jans, _fail, "Participant's answer is better than jury's one");
    quitif(pans < jans, _wa, "Jury's answer is better than participant's one");
    
    quitf(_ok, "Ok");
}
